javax.persistence

## Enum PessimisticLockScope

- java.lang.Object
- - java.lang.Enum<PessimisticLockScope>
  - - javax.persistence.PessimisticLockScope

All Implemented Interfaces:
  Serializable, Comparable<PessimisticLockScope>

    public enum PessimisticLockScope
    extends Enum<PessimisticLockScope>

Defines the values of the `javax.persistence.lock.scope` property for pessimistic locking. This property may be passed as an argument to the methods of the `EntityManager`, `Query`, and `TypedQuery` interfaces that allow lock modes to be specified or used with the `NamedQuery` annotation.

Since:
  Java Persistence 2.0

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`EXTENDED` In addition to the behavior for `PessimisticLockScope.NORMAL`, element collections and relationships owned by the entity that are contained in join tables will be locked if the `javax.persistence.lock.scope` property is specified with a value of `PessimisticLockScope.EXTENDED`.
`NORMAL` This value defines the default behavior for pessimistic locking.

### Method Summary

All Methods Static Methods Concrete Methods
`static PessimisticLockScope` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static PessimisticLockScope[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### NORMAL

    public static final PessimisticLockScope NORMAL

This value defines the default behavior for pessimistic locking.

The persistence provider must lock the database row(s) that correspond to the non-collection-valued persistent state of that instance. If a joined inheritance strategy is used, or if the entity is otherwise mapped to a secondary table, this entails locking the row(s) for the entity instance in the additional table(s). Entity relationships for which the locked entity contains the foreign key will also be locked, but not the state of the referenced entities (unless those entities are explicitly locked). Element collections and relationships for which the entity does not contain the foreign key (such as relationships that are mapped to join tables or unidirectional one-to-many relationships for which the target entity contains the foreign key) will not be locked by default.

#### EXTENDED

    public static final PessimisticLockScope EXTENDED

In addition to the behavior for `PessimisticLockScope.NORMAL`, element collections and relationships owned by the entity that are contained in join tables will be locked if the `javax.persistence.lock.scope` property is specified with a value of `PessimisticLockScope.EXTENDED`. The state of entities referenced by such relationships will not be locked (unless those entities are explicitly locked). Locking such a relationship or element collection generally locks only the rows in the join table or collection table for that relationship or collection. This means that phantoms will be possible.

### Method Detail

#### values

    public static PessimisticLockScope[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (PessimisticLockScope c : PessimisticLockScope.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static PessimisticLockScope valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null